
#include <LEDA/window.h>


#include <LEDA/graph.h>
#include <LEDA/map.h>
#include <LEDA/float_kernel.h>
#include <LEDA/geo_alg.h>

void CRUST(const list<point>& S, GRAPH<point,int>& G) 
{
  list<point> L = S;

  GRAPH<circle,point> VD;

  VORONOI(L,VD);

  // add Voronoi vertices and mark them

  map<point,bool> voronoi_vertex(false);

  node v;
  forall_nodes(v,VD)
  { if (VD.outdeg(v) < 2) continue; 
    point p = VD[v].center();
    voronoi_vertex[p] = true;
    L.append(p);
  }

  DELAUNAY_TRIANG(L,G);

  list<node> vlist;
  forall_nodes(v,G)
     if (voronoi_vertex[G[v]]) vlist.append(v);

  G.del_nodes(vlist);
}


main()
{ window W; W.display(); 
  W.set_node_width(2); W.set_line_width(2);
  point p;
  list<point> S;
  GRAPH<point,int> G;
  
  while ( W >> p )
  { S.append(p);
    CRUST(S,G);
    
    node v; edge e;
    W.clear();
    forall_nodes(v,G) W.draw_node(G[v]);
    forall_edges(e,G) W.draw_segment(G[source(e)], G[target(e)]);

  }
}
      
