
#line 645 "numbers.lw"
#include <LEDA/bigfloat.h>
#include <LEDA/IO_interface.h>


#line 653 "numbers.lw"
main(){
int m;

#line 679 "numbers.lw"
IO_interface I("Euler's Number");

I.write_demo("We compute an approximation of Euler's number e = 2,71... \
with error less than 2^{-m}. You will be asked to input m. The approximation \
is computed by summing a sufficient number of terms of the series");

I.write_demo("1/1! + 1/2! + 1/3! + 1/4! +  ");

I.write_demo("using the bigfloat number type.");

m = I.read_int("m = ");

float T = used_time();


#line 657 "numbers.lw"
bigfloat::set_precision(2*m);   
bigfloat::set_rounding_mode(TO_ZERO);
bigfloat z = 2; 
integer fac = 2; 
int n = 2; 
while ( fac.length() < m + 3 )
  {  // fac = n! and z approximates 1/0! + 1/1! + ... + 1/(n-1)!
    z = z + 1/bigfloat(fac); 
    n++; fac = fac * n;
  }
// |z - e| <= 2^{m-1} at this point

z = round(z,m+3,TO_NEAREST);


#line 695 "numbers.lw"
I.write_demo("z = " + to_string(z)); 

I.write_demo("The computation of z took ", used_time(T), " seconds.");


#line 671 "numbers.lw"
                    
}

